function boot() {
    setScriptButtons([
        { label: "输出脚本版本", func: "showVersion", confirmText: "确定要看吗？" },
        { label: "叫机器人过来", func: "callRobot", inputEntityName: "CallRobotDirect" },
        { label: "生成库存明细", func: "createInv", inputEntityName: "CreateInv" }
    ]);
}
function showVersion() {
    return JSON.stringify({ message: "1.1.1" });
}
function callRobot(input) {
    return JSON.stringify({ message: `叫机器人 ${input["robot"]} 到库位 ${input["toBin"]}` });
}
function createInv(input) {
    const tc = base.traceContext();
    const list = [];
    input["state"] = "Storing";
    list.push(input);
    bz.fixCreateInvLayout(tc, list);
    return JSON.stringify({ message: `${input}` });
}
function bpNumToPrefixFixLenString(tc, inputParams) {
    const num = inputParams["num"];
    const length = inputParams["length"];
    const prefix = inputParams["prefix"] || "";
    const numStr = prefix + num.toString().padStart(length, "0");
    return JSON.stringify({ outputParams: { numStr } });
}
/**
 * 列表界面扩展按钮
 */
function checkMyRobotTasks(req) {
    var _a;
    const message = `收到列表界面扩展按钮，选中 ID：${(_a = req.selectedIds) === null || _a === void 0 ? void 0 : _a.join(",")}`;
    return JSON.stringify({ message });
}
function beforeMyRobotTask(req) {
    const message = `保存前，ID：${req.evId}，值：${base.jsonToString(req.ev)}`;
    base.logInfo(base.traceContext(), message);
    return JSON.stringify({ message });
}
function afterMyRobotTask(req) {
    const message = `保存后，ID：${req.evId}`;
    base.logInfo(base.traceContext(), message);
    return JSON.stringify({ message });
}
function fetchErpPurchaseOrderToReturn(req) {
    const tc = base.traceContext();
    const erpPurchaseOrderId = req.ev["erpPurchaseOrderId"];
    base.logInfo(tc, `采购订单号：${erpPurchaseOrderId}`);
    const lines = [];
    for (let i = 0; i < 10; i++) {
        lines.push({ btMaterial: "MT-001-0001", qty: 100 + i });
    }
    req.ev["btLines"] = lines;
    return base.jsonToString({ modifiedEv: req.ev });
}
