function boot() {
  setScriptButtons([
    {label: "输出脚本版本", func: "showVersion", confirmText: "确定要看吗？"},
    {label: "叫机器人过来", func: "callRobot", inputEntityName: "CallRobotDirect"},
    {label: "生成库存明细", func: "createInv", inputEntityName: "CreateInv"}
  ])
}


function showVersion() {
  return JSON.stringify({message: "1.1.1"})
}

function callRobot(input: MapToAny) {
  return JSON.stringify({message: `叫机器人 ${input["robot"]} 到库位 ${input["toBin"]}`})
}

function createInv(input: MapToAny) {
  const tc = base.traceContext()
  const list = []
  input["state"] = "Storing"
  list.push(input)
  bz.fixCreateInvLayout(tc, list)
  return JSON.stringify({message: `${input}`})
}

function bpNumToPrefixFixLenString(tc: TraceContext, inputParams: MapToAny) {
  const num = inputParams["num"] as number
  const length = inputParams["length"] as number
  const prefix = inputParams["prefix"] || ""

  const numStr = prefix + num.toString().padStart(length, "0")

  return JSON.stringify({outputParams: {numStr}})
}

/**
 * 列表界面扩展按钮
 */
function checkMyRobotTasks(req: CallEntityExtButtonReq) {
  const message = `收到列表界面扩展按钮，选中 ID：${req.selectedIds?.join(",")}`
  return JSON.stringify({message})
}

function beforeMyRobotTask(req: CallEntityExtButtonReq) {
  const message = `保存前，ID：${req.evId}，值：${base.jsonToString(req.ev)}`
  base.logInfo(base.traceContext(), message)
  return JSON.stringify({message})
}

function afterMyRobotTask(req: CallEntityExtButtonReq) {
  const message = `保存后，ID：${req.evId}`
  base.logInfo(base.traceContext(), message)
  return JSON.stringify({message})
}

function fetchErpPurchaseOrderToReturn(req: CallEntityExtButtonReq) {
  const tc = base.traceContext()
  const erpPurchaseOrderId = req.ev["erpPurchaseOrderId"]
  base.logInfo(tc, `采购订单号：${erpPurchaseOrderId}`)

  const lines: MapToAny[] = []
  for (let i = 0; i < 10; i++) {
    lines.push({btMaterial: "MT-001-0001", qty: 100 + i})
  }

  req.ev["btLines"] = lines

  return base.jsonToString({modifiedEv: req.ev})
}